﻿/*common js*/
if (typeof (_smt) == "undefined")
	_smt = {};

_smt.$ = function() {
	var elements = new Array();
	for (var i = 0; i < arguments.length; i++) {
		var element = arguments[i];
		if (typeof element == 'string')
			element = document.getElementById(element);
		if (arguments.length == 1)
			return element;
		elements.push(element);
	}
	return elements;
}

_smt.addEvent = function (elm, evType, fn, useCapture) {
	if (elm.addEventListener) {
		elm.addEventListener(evType, fn, useCapture);
		return true;
	}
	else if (elm.attachEvent) {
		var r = elm.attachEvent('on' + evType, fn);
		return r;
	}
	else {
		elm['on' + evType] = fn;
	}
}


_smt.mouseX = function (e) {
	var posx = 0;
	if (!e) var e = window.event;
	if (e.pageX) {
		posx = e.pageX;
	}
	else if (e.clientX) {
		posx = e.clientX + document.body.scrollLeft
				+ document.documentElement.scrollLeft;
	}

	return posx;
}

_smt.mouseY = function (e) {
	var posy = 0;
	if (!e) var e = window.event;
	if (e.pageY) {
		posy = e.pageY;
	}
	else if (e.clientY) {
		posy = e.clientY + document.body.scrollTop
				+ document.documentElement.scrollTop;
	}

	return posy;
}

_smt.findPos = function (obj) {
	var curleft = curtop = 0;

	if (obj.offsetParent) {

		do {
			curleft += obj.offsetLeft;
			curtop += obj.offsetTop;
		} while (obj = obj.offsetParent);
	}

	return [curleft, curtop];
}

_smt.BindAsEventListener = function(object, fun) {
	return function(event) {
		return fun.call(object, (event || window.event));
	}
}

/*file select dialog scripts*/

_smt.fileSelectManager = function( triggerId, fileContainerId, fileId ){
	this.triggerObj = _smt.$( triggerId );
	this.fileContainerObj = _smt.$( fileContainerId );
	this.fileObj = _smt.$( fileId );
		
	this.__handleMouseMove = _smt.BindAsEventListener(this, this._handleMouseMove);
	this.__setDisplay = _smt.BindAsEventListener(this, this._setDisplay);
}


_smt.fileSelectManager.prototype = {
	init : function () {
		_smt.addEvent( this.triggerObj, 'mousemove', this.__handleMouseMove);
		_smt.addEvent( this.fileContainerObj, 'mousemove', this.__handleMouseMove);
		_smt.addEvent( this.fileObj, 'change', this.__setDisplay);
	}
	,
	_handleMouseMove : function (e) {
		e = e || window.event;
		var elem = e.srcElement || e.target;
		
		//console.debug('in _handleMouseMove');
		
		var pElem = this.triggerObj;
		var pLeft = _smt.findPos(pElem)[0]; //trigger left
		var pTop = _smt.findPos(pElem)[1]; //trigger top
		var mLeft = _smt.mouseX(e); //mouse left
		var mTop = _smt.mouseY(e);	//mouse top
		var eWidth = pElem.offsetWidth; //trigger width
		var eHeight = pElem.offsetHeight; //trigger height
		var cWidth = this.fileContainerObj.offsetWidth; //container width
		var cHeight = this.fileContainerObj.offsetHeight; //container height

		var oLeft = -10; //offset left
		var oTop = -8;	//offset top
		
		if ((mTop > pTop && mLeft > pLeft)
			&& (mTop < (pTop + eHeight) && mLeft < (pLeft + eWidth))) {

			this.fileContainerObj.style.left = (mLeft - pLeft + oLeft) + 'px';
			this.fileContainerObj.style.top = (mTop - pTop + oTop) + 'px';
		}
		else{
			if( mTop >= pTop + eHeight )
				this.fileContainerObj.style.top = (mTop - pTop + oTop/2 ) - cHeight;
			
			if( mTop <= pTop )
				this.fileContainerObj.style.top =  (mTop - pTop ) + 'px';
			
			//console.debug('mTop' + mTop + 'pTop' + pTop)
			//console.debug('mLeft' + mLeft + 'pLeft' + pLeft)
			if( mLeft >= pLeft + eWidth )
				this.fileContainerObj.style.left = ( mLeft - pLeft + oLeft * 2 )+ 'px';
			
			if( mLeft <= pLeft )
				this.fileContainerObj.style.left = (mLeft - pLeft )+ 'px';
		}
			
	}
	,
	_setDisplay : function(){
		var rawFile = this.fileObj.value;
		this.triggerObj.value = rawFile.slice(rawFile.lastIndexOf('\\') + 1);
	}
}

